package com.fs.company.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fs.common.annotation.Excel;
import com.fs.common.core.domain.BaseEntity;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.Date;
import java.util.List;

@Data
public class CompanyUser extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 用户ID */
    private Long userId;

    /** 公司ID */
    @Excel(name = "公司ID")
    private Long companyId;

    /** 公司名称 */
    private String companyName;

    public String getCorpId() {
        return corpId;
    }

    public void setCorpId(String corpId) {
        this.corpId = corpId;
    }

    private String corpId;

    /** 部门编号 */
    @Excel(name = "部门编号")
    private Long deptId;

    @Excel(name = "部门名称")
    private String deptName;

    /** 用户账号 */
    @Excel(name = "用户账号")
    private String userName;

    /** 用户昵称 */
    @Excel(name = "用户昵称")
    private String nickName;

    /** 用户类型（00系统用户） */
    @Excel(name = "用户类型", readConverterExp = "0=0系统用户")
    private String userType;

    /** 用户邮箱 */
    @Excel(name = "用户邮箱")
    private String email;

    /** 手机号码 */
    @Excel(name = "手机号码")
    private String phonenumber;
    /** 岗位 */
    private List<CompanyPost> posts;

    /** 用户性别（0男 1女 2未知） */
    @Excel(name = "用户性别", readConverterExp = "0=男,1=女,2=未知")
    private String sex;

    /** 头像地址 */
    @Excel(name = "头像地址")
    private String avatar;

    /** 身份证号 */
    @Excel(name = "身份证号")
    private String idCard;

    /** 密码 */
    @Excel(name = "密码")
    private String password;

    /** 帐号状态（0正常 1停用） */
    @Excel(name = "帐号状态", readConverterExp = "0=正常,1=停用")
    private String status;

    /** 删除标志（0代表存在 2代表删除） */
    private String delFlag;

    private String qwUserId;
    private Integer qwStatus;

    /** 医生id */
    private Long doctorId;

    private String unionId;

    public String getUnionId() {
        return unionId;
    }

    public void setUnionId(String unionId) {
        this.unionId = unionId;
    }

    public String getIdCard() {
        return idCard;
    }

    public void setIdCard(String idCard) {
        this.idCard = idCard;
    }

    /** 最后登录IP */
    @Excel(name = "最后登录IP")
    private String loginIp;

    /** 最后登录时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "最后登录时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date loginDate;


    /** 移动端登陆token */
    @Excel(name = "移动端登陆token")
    private String token;

    /** 是否删除 */
    @Excel(name = "是否删除")
    private Integer isDel;

    private String openId;


    private CompanyDept dept;

    /** 角色对象 */
    private List<CompanyRole> roles;

    /** 角色组 */
    private Long[] roleIds;

    /** 岗位组 */
    private Long[] postIds;

    private String firstchar;
    private String postName;


    private String qrCodeWeixin;

    private String qrCodeWecom;

    private String jpushId;

    private String callerNo;

    private String voicePrintUrl;

    private String addressId;

    //绑定二维码
    private String bindCode;

    private String imNickName;

    public String getImNickName() {
        return imNickName;
    }

    public void setImNickName(String imNickName) {
        this.imNickName = imNickName;
    }

    /** 看课域名 */
    private String domain;

    /** 是否审核 */
    private Integer isAudit;

    /** 用户上级id */
    private Long parentId;

    /** 微信小程序OPENID（如果有小程序授权） */
    private String  maOpenId;

    /** 是否需要单独注册会员，1-是，0-否（用于个微销售分享看课） */
    private Integer isNeedRegisterMember;

    /** 是否允许所有方式注册会员，1-是，0-否，默认1（用于个微注册会员） */
    private Integer isAllowedAllRegister;

    /** 绑定的公司用户ID */
    private Long bindCompanyUserId;

    @TableField(exist = false)
    private List<Long> deptList;

    public String getMaOpenId() {
        return maOpenId;
    }

    public void setMaOpenId(String maOpenId) {
        this.maOpenId = maOpenId;
    }

    public Integer getIsAllowedAllRegister() {
        return isAllowedAllRegister;
    }

    public void setIsAllowedAllRegister(Integer isAllowedAllRegister) {
        this.isAllowedAllRegister = isAllowedAllRegister;
    }

    public Long getParentId() {
        return parentId;
    }

    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }

    public Integer getIsNeedRegisterMember() {
        return isNeedRegisterMember;
    }

    public void setIsNeedRegisterMember(Integer isNeedRegisterMember) {
        this.isNeedRegisterMember = isNeedRegisterMember;
    }

    public String getDomain() {
        return domain;
    }

    public void setDomain(String domain) {
        this.domain = domain;
    }

    public String getAddressId() {
        return addressId;
    }

    public void setAddressId(String addressId) {
        this.addressId = addressId;
    }

    public String getVoicePrintUrl() {
        return voicePrintUrl;
    }

    public void setVoicePrintUrl(String voicePrintUrl) {
        this.voicePrintUrl = voicePrintUrl;
    }

    public String getCallerNo() {
        return callerNo;
    }

    public void setCallerNo(String callerNo) {
        this.callerNo = callerNo;
    }

    public String getJpushId() {
        return jpushId;
    }

    public String getQwUserId() {
        return qwUserId;
    }

    public void setQwUserId(String qwUserId) {
        this.qwUserId = qwUserId;
    }

    public Integer getQwStatus() {
        return qwStatus;
    }

    public void setQwStatus(Integer qwStatus) {
        this.qwStatus = qwStatus;
    }

    public void setJpushId(String jpushId) {
        this.jpushId = jpushId;
    }

    public String getQrCodeWeixin() {
        return qrCodeWeixin;
    }

    public void setQrCodeWeixin(String qrCodeWeixin) {
        this.qrCodeWeixin = qrCodeWeixin;
    }

    public String getQrCodeWecom() {
        return qrCodeWecom;
    }

    public void setQrCodeWecom(String qrCodeWecom) {
        this.qrCodeWecom = qrCodeWecom;
    }

    public String getOpenId() {
        return openId;
    }

    public void setOpenId(String openId) {
        this.openId = openId;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getNickName() {
        return nickName;
    }


    public void setNickName(String nickName) {
        this.nickName = nickName;
    }

    public String getFirstchar() {
        return firstchar;
    }

    public void setFirstchar(String firstchar) {
        this.firstchar = firstchar;
    }

    public String getPostName() {
        return postName;
    }

    public void setPostName(String postName) {
        this.postName = postName;
    }

    public String getDeptName() {
        return deptName;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    public CompanyDept getDept() {
        return dept;
    }

    public void setDept(CompanyDept dept) {
        this.dept = dept;
    }

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public boolean isAdmin()
    {
        return isAdmin(this.userType);
    }

    public static boolean isAdmin(String userType)
    {
        if(userType!=null&&(userType.equals("00") || userType.equals("02"))){
            return true;
        }
        else return false;
    }

    public List<CompanyRole> getRoles() {
        return roles;
    }

    public void setRoles(List<CompanyRole> roles) {
        this.roles = roles;
    }

    public Long[] getRoleIds() {
        return roleIds;
    }

    public void setRoleIds(Long[] roleIds) {
        this.roleIds = roleIds;
    }

    public Long[] getPostIds() {
        return postIds;
    }

    public void setPostIds(Long[] postIds) {
        this.postIds = postIds;
    }


    public void setUserId(Long userId)
    {
        this.userId = userId;
    }

    public Long getUserId()
    {
        return userId;
    }
    public void setCompanyId(Long companyId)
    {
        this.companyId = companyId;
    }

    public Long getCompanyId()
    {
        return companyId;
    }
    public void setDeptId(Long deptId)
    {
        this.deptId = deptId;
    }

    public Long getDeptId()
    {
        return deptId;
    }

    public void setUserType(String userType)
    {
        this.userType = userType;
    }

    public String getUserType()
    {
        return userType;
    }
    public void setEmail(String email)
    {
        this.email = email;
    }

    public String getEmail()
    {
        return email;
    }
    public void setPhonenumber(String phonenumber)
    {
        this.phonenumber = phonenumber;
    }

    public String getPhonenumber()
    {
        return phonenumber;
    }
    public void setSex(String sex)
    {
        this.sex = sex;
    }

    public String getSex()
    {
        return sex;
    }
    public void setAvatar(String avatar)
    {
        this.avatar = avatar;
    }

    public String getAvatar()
    {
        return avatar;
    }

    public void setPassword(String password)
    {
        this.password = password;
    }

    public String getPassword()
    {
        return password;
    }
    public void setStatus(String status)
    {
        this.status = status;
    }

    public String getStatus()
    {
        return status;
    }
    public void setDelFlag(String delFlag)
    {
        this.delFlag = delFlag;
    }

    public String getDelFlag()
    {
        return delFlag;
    }
    public void setLoginIp(String loginIp)
    {
        this.loginIp = loginIp;
    }

    public String getLoginIp()
    {
        return loginIp;
    }
    public void setLoginDate(Date loginDate)
    {
        this.loginDate = loginDate;
    }

    public Date getLoginDate()
    {
        return loginDate;
    }


    public void setToken(String token)
    {
        this.token = token;
    }

    public String getToken()
    {
        return token;
    }
    public void setIsDel(Integer isDel)
    {
        this.isDel = isDel;
    }

    public Integer getIsDel()
    {
        return isDel;
    }

    public Integer getIsAudit() {
        return isAudit;
    }

    public void setIsAudit(Integer isAudit) {
        this.isAudit = isAudit;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public List<CompanyPost> getPosts() {
        return posts;
    }

    public void setPosts(List<CompanyPost> posts) {
        this.posts = posts;
    }
    public String getBindCode() {
        return bindCode;
    }

    public void setBindCode(String bindCode) {
        this.bindCode = bindCode;
    }
}
